//=============================================================================
// BotzJunction.
// Instrucciones:
//	-Si se define PreTouch, colocar los caminos adyacentes donde quieres que doblen antes
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class BotzJunction expands BaseBotzWP;

#exec TEXTURE IMPORT NAME=BWP_Junction FILE=..\CompileData\BWP_Junction.bmp FLAGS=2

var(PresetNav) bool PreTouch; //Al estar a un camino de alcanzar este punto, acta como si lo hubiera hecho, tocando la juncin antes de llegar a ella y simulando un giro humano.

var BaseBotzWP LinkedPaths[8];	//AutoDefinido
var BotzJunction LinkedJunctions[8]; //AutoDefinido
var float LinkedDistances[8]; //No tocar, los BPO se encargan, asi es como mato iteraciones
var EPathType SpecialFactor[8];			//Pre-Definido por el WpLoaderBase

var name IgnoredName;
var BotzWp IgnoredWp;

var BotzPathObject BestObjects[60], AltObjects[60], TranslocObjects[60], JumpObjects[60];
var(PresetNav) BaseBotzWP DefinedGoals[60];
var(PresetNav) BotzJunction BestPath[60];
var(PresetNav) BotzJunction PresetTransloc[60];	//Opcional
var(PresetNav) BotzJunction PresetJump[60];		//Opcional
var(PresetNav) BotzJunction TacticalAlt[60];	//Opcional

function BaseBotzWP SearchAPath(BaseBotzWP PathTarget, BaseBotzWP Origen, out float Dist, optional bool bIgnoreJunc)
{
	local BotzJunction Desired, Candidate[2];
	local float Dists[2];
	local float BestDist, TempFloat;
	local int i;
	local bool bIgnore;

	Dist = 0;
	if ( BotzJunction(PathTarget) != none )
		Desired = BotzJunction(PathTarget);

	if (Desired == none)
	{
		FindJunctionsTo( PathTarget, Candidate, Dists );
		For ( i=0 ; i<2 ; i++ )
		{
			if ( Candidate[i] == self )
			{
				Desired = Candidate[ abs(i - 1) ];
				Dist = BotzWP(PickLinkedTo( Desired)).PathInfo.GetDist( self, Desired);
				return PickLinkedTo( Desired);
			}
		}
		TempFloat = MeasureDistance( Candidate[0] );
		BestDist = TempFloat + Dists[0];
		Desired = Candidate[0];

		if ( Candidate[1] != none )
			TempFloat = MeasureDistance( Candidate[1] );
		if ( (TempFloat + Dists[1] ) < BestDist)
		{
			BestDist = TempFloat + Dists[1];
			Dist = BestDist;
			Desired = Candidate[1];
		}
		bIgnore = True;
	}

	if ( Desired == self )
		return self;

	if ( Desired != none && !bIgnore)
	{
		if ( DirectLinkTo(Desired) )
		{
			Dist = BotzWP(PickLinkedTo( Desired)).PathInfo.GetDist( self, Desired);
			return PickLinkedTo( Desired);
		}
	}


	if ( Desired != none )
	{
		if ( BotzGoal(Desired) != none )
			For ( i=0 ; i<60 ; i++ )
				if ( DefinedGoals[i] == BotzGoal(Desired).TheJunc )
				{
					Dist = MeasureDistance( Desired);
					return PickLinkedTo( BestPath[i] );
				}
		else
			For ( i=0 ; i<60 ; i++ )
				if ( DefinedGoals[i] == Desired )
				{
					Dist = MeasureDistance( Desired);
					return PickLinkedTo( BestPath[i] );
				}
	}
}

function bool DirectLinkTo( BotzJunction BJ)
{
	local int i;

	For ( i=0 ; i<8 ; i++ )
		if ( LinkedJunctions[i] == BJ )
			return true;
	return False;
}
function BaseBotzWP PickLinkedTo( BotzJunction LinkTarget)
{
	local int i;

	For ( i=0 ; i<8 ; i++ )
		if ( LinkedJunctions[i] == LinkTarget )
			return LinkedPaths[i];
	Assert( False);	//Siempre debera detenerse en Return, sino hay algo mal.
}

/*
function float MeasureDistance( BotzJunction Target)
{
	local int i;
	local bool bSetSelf;
	local float DistGiver;
	local BotzJunction NextPath, CurrentPath, oTarget;

	DistGiver = 0;
	bSetSelf = True;

	if ( BotzGoal(Target) != none )
		oTarget = BotzGoal(Target).TheJunc;
	else
		oTarget = Target;

	while (true)
	{
		if ( bSetSelf )
			CurrentPath = self;
		else
			CurrentPath = NextPath;
		bSetSelf = False;
		For ( i=0 ; i<60 ; i++ )
			if ( CurrentPath.DefinedGoals[i] == oTarget )
			{
				NextPath = BestPath[i];
				i = 60;
			}			
		if ( NextPath == CurrentPath )
		{
			For ( i=0 ; i<8 ; i++ )
				if ( CurrentPath.LinkedJunctions[i] == Target )
				{
					NextPath = Target;
					i = 8;
				}
			if ( NextPath != Target )
			{	Log("Error: no hay camino unido desde"@CurrentPath@"hasta"@Target);
				return DistGiver;
			}
		}

		For ( i=0; i<8 ; i++ )
			if ( CurrentPath.LinkedJunctions[i] == NextPath )
			{
				DistGiver += 
BotzWP( CurrentPath.LinkedPaths[i] ).PathInfo.GetDist(CurrentPath,NextPath);
				i = 8;
			}
		if ( NextPath == Target || NextPath == none )
			break;
	}

	return DistGiver;
}
*/

function float MeasureDistance( BotzJunction aTarget)
{
	if ( (aTarget == none) || (aTarget==self) )
		return 0.0;

	return GetDistTo(aTarget);
}


function float GetDistTo( BotzJunction TheTarget)
{
	local int i;
	local BotzJunction BJ, oTarget;

	if (TheTarget == self)
		return 0.0;

	if ( BotzGoal(TheTarget) != none )
		oTarget = BotzGoal(TheTarget).TheJunc;
	else
		oTarget = TheTarget;


	if ( DirectLinkTo( TheTarget) )
		return BotzWP(PickLinkedTo(TheTarget)).PathInfo.GetDist(self,TheTarget);

	For (i=0 ; i<60 ; i++)
	{
		if (DefinedGoals[i] == oTarget)
		{
			BJ = BestPath[i];
			break;
		}
	}

	if (BJ == none)
		Log("Error: no hay conexion desde"@self@"hasta"@TheTarget);

	return BotzWP(PickLinkedTo(BJ)).PathInfo.GetDist(self,BJ) + BJ.GetDistTo(TheTarget);
}

defaultproperties
{
     AddedOffset=30.000000
     Texture=Texture'FerBotz.BWP_Junction'
     bCollideActors=True
}
