//=============================================================================
// The extended navigation point
// Native branch class only
// This actor should automatically become bNoDelete after being spawned
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//=============================================================================
class Botz_NavigBase expands NavigationPoint;

var float MaxDistance; //Maximum hook distance, used by automatic pather, setting to 0 ignores all pathing
var bool bPushSave;
var bool bOneWayInc; //Limits Incoming paths
var bool bOneWayOut; //Limits Outgoing paths
var string FriendlyName;

enum EPathMode
{
	PM_None, //Don't path
	PM_Normal, //Do normal processing
	PM_Forced //Force this path!
};

function bool PostPathEvaluate( botz other)
{
	return false;
}

final function LockActor( bool bLock); 
final function int CreateReachSpec();
final function PathCandidates();
final function int ExistingPath( actor Dest);
final function bool EditReachSpec( int ReachSpec, actor Start, actor End, optional float CollisionHeight, optional float CollisionRadius, optional bool bTele);
final function int UnusedReachSpec();
static final function ConnectedDests( NavigationPoint Start, out Actor End, out int ReachSpecIdx);
static final function int IsConnectedTo( NavigationPoint N, NavigationPoint Other, optional bool bIncPruned);

// MOVE TO NATIVE CODE LATER!
static final function int FreePathSlot( NavigationPoint N)
{
	local int i;

	For ( i=0 ; i<16 ; i++ )
		if ( N.Paths[i] == -1 )
			return i;
	return -1;
}

// MOVE TO NATIVE CODE LATER!
static final function int FreeUpstreamSlot( NavigationPoint N)
{
	local int i;

	For ( i=0 ; i<16 ; i++ )
		if ( N.UpstreamPaths[i] == -1 )
			return i;
	return -1;
}

event EPathMode IsCandidateTo( Botz_NavigBase Other)
{
	return PM_Normal;
}

event EPathMode OtherIsCandidate( NavigationPoint Nav)
{
	if ( Nav.IsA('LiftCenter') ) //No lift centers
		return PM_None;
	if ( Nav.IsA('SpawnPoint') && (VSize(Nav.Location - Location) > MaxDistance * 0.5) ) //Avoid distant SpawnPoints
		return PM_None;
	if ( FastTrace( Nav.Location) )
		return PM_Normal;
	return PM_None;
}

event AddPathHere( NavigationPoint Start, NavigationPoint End, bool bForce);
event FinishedPathing();
function int WalkableCost( NavigationPoint Start, NavigationPoint End);

defaultproperties
{
	FriendlyName="Base Waypoint"
	bStatic=False
	bNoDelete=False
	MaxDistance=200
	Texture=Texture'FerBotz.BWP_Normal'
	bCollideWhenPlacing=false
	Style=3
	SpriteProjForward=4
	DrawScale=0.5
}