//==================================================================================
// MasterGasterFer => El agregador de caminos en-juego
// Para lograr que los botz se translocalizen, salten y otras cosas.
// Un botz lo crea, este duplica los JumpSpots y TranslocNodes, y para evitar que se
// vuelvan a duplicar, esta entidad no se borra (indicando que est todo hecho)
// Tambien monitorea el estado de los botz y se asegura de que no se 'tranquen'
// Este actor no es replicada, a diferencia del mutador de botz
//
// For testing purposes, do not modify or redistribute
// Have suggestions? Contact me.
// caco_fff@hotmail.com - Higor at UT99.org
//==================================================================================
class MasterGasterFer expands InfoPoint;

const BFM = class'BotzFunctionManager';

var() string LevelName;
var() class<BaseSpawner> SpawnerClass;
var() class<WpLoaderBase> BasicLoaderClass;
var() BaseSpawner TheSpawner;
var() WpLoaderBase BwpCreator;
var BotzNode BNodeList;
var class<BotzTargetAdder> TargeterClass;
var BotzTargetAdder MyTargeter;

var float DistInvScaler;
var BotzMutator TheMutator;
var int TickCount;

var Botz OldBotzList[63];
var int OldBotzCount;

var BotzWeaponProfile WProfiles[63];
var int WProfileCount;

// Tranke y no reaparecen
var Botz Tranker;
var float TrankTime;

// Tranke con Teletransportadores
var Botz TeleTranker;
var Teleporter TeleTranked;
var float TeleTrankTime;
var int TeleSteps;

// Tranke luego de transloc
var Botz TTranker;
var vector TLocation;
var float TTime;

//Navigation point static array
var NavigationPoint NavArray[384];
var int LCenter; //0
var int LExit; //1
var int JSpot; //2
var int TStart; //3
var int TEnd; //4
var int NavOther; //5 - this is a placeholder, add more stuff here using IsA checks

var class<Weapon> SniperWeapons[24];	//Soporte externo
var int iSniperW;
var localized string SniperWeaponsSTR[24];

/*
private final function UpBlock( int iBloq)
{
	//iBloq means where we're adding a new element, move all blocks above
	//Block 0 left untouched and don't move upper block if adding there
	//A free space will be left on iBloq, IT MUST BE FILLED
	if ( iBloq < 4 )
		NavArray[ LCenter+LExit+JSpot+TStart+TEnd ] = NavArray[ LCenter+LExit+JSpot+TStart ];
	if ( iBloq < 3 )
		NavArray[ LCenter+LExit+JSpot+TStart ] = NavArray[ LCenter+LExit+JSpot ];
	if ( iBloq < 2 )
		NavArray[ LCenter+LExit+JSpot ] = NavArray[ LCenter+LExit ];
	if ( iBloq < 1 )
		NavArray[ LCenter+LExit ] = NavArray[ LCenter ];
	
}
*/

event PostBeginPlay()
{
	local string GameString;
	local int i;
	local NavigationPoint N;
	local bool bReturnInside;
	local Botz_PathLoader aLoader;

	SetLocation(vect(0,0,0));
	SetRotation(Rot(0,0,0));
	SetOwner( none);

	GameString = GetItemName( string(Level.Game.Class));
	LevelName = GetLevelName( string(self) );
	SpawnerClass = class<BaseSpawner>(
 DynamicLoadObject( LevelName$"Botz."$LevelName$"Spawn", class'Class', true) );
	BasicLoaderClass = class<WpLoaderBase>(
 DynamicLoadObject( LevelName$"Botz."$LevelName$"BWP", class'Class', true) );

	if ( (SpawnerClass == none) && (BasicLoaderClass == none) )
	{
		BFM.static.ReplaceText(LevelName, "]", "_1");
		BFM.static.ReplaceText(LevelName, "[", "_2");
		BFM.static.ReplaceText(LevelName, "|", "_3");
		SpawnerClass = class<BaseSpawner>(
	 DynamicLoadObject( LevelName$"Botz."$LevelName$"Spawn", class'Class', true) );
		BasicLoaderClass = class<WpLoaderBase>(
	 DynamicLoadObject( LevelName$"Botz."$LevelName$"BWP", class'Class', true) );
	}

	TargeterClass = class<BotzTargetAdder>(
 DynamicLoadObject( GameString$"UBZFV."$GameString$"UBZSupport", class'Class', true) );

	For ( i=0 ; i<24 ; i++ )
		if ( SniperWeaponsSTR[i] != "" )
		{
			SniperWeapons[iSniperW] = Class<Weapon>( DynamicLoadObject( SniperWeaponsSTR[i], class'Class') );
			if ( SniperWeapons[iSniperW] != none )
				iSniperW++;
		}

	SetTimer( 0.5, True);
//	StartSpecialWp();

	if (SpawnerClass != none)
		TheSpawner = spawn(SpawnerClass);
	if (BasicLoaderClass != none)
	{
		BwpCreator = Spawn(BasicLoaderClass);
		BwpCreator.Master = self;
		BwpCreator.BeginTheWpProcess();
	}
	if ( TargeterClass == none ) //TARGETER IS MANDATORY NOW, FOR SEMI-ULTRA BOTZ BWP SUPPORT
		TargeterClass = class'FerBotz.BotzTargetAdder';

	MyTargeter = Spawn(TargeterClass);
	MyTargeter.MyMaster = self;


// Cargar perfiles de armas
	//This will crash the game if MasterGasterFer is spawned twice, which is intended
	//Weapon profiles are created in the context of the level
	WProfiles[0] = new(self,'BotzBaseWeaponProfile') class'BotzWeaponProfile';
	//Default weapons
	WProfiles[1] = new(self) class'Botz_WePro_Piston';
	WProfiles[1].PostInit();
	WProfiles[2] = new(self) class'Botz_WePro_BioRifleTEST';
	WProfiles[2].PostInit();
	WProfiles[3] = new(self) class'Botz_WePro_FlakTEST';
	WProfiles[3].PostInit();
	WProfiles[4] = new(self) class'Botz_WePro_ShockTEST';
	WProfiles[4].PostInit();
	WProfiles[5] = new(self) class'Botz_WePro_RocketTEST';
	WProfiles[5].PostInit();
	
	WProfileCount = 6;

	CalcInvScaler();
	TickCount = 6;	//6 ticks para notificar al mutador

	ForEach AllActors (class'Botz_PathLoader', aLoader)
		break;
	if ( aLoader == none )
		Spawn(class'Botz_PathLoader').LoadNodes();

	For ( N=Level.NavigationPointList ; N!=none ; N=N.nextNavigationPoint )
	{
		if ( classIsChildOf( N.class, class'Botpack.TranslocDest') )
		{
			//Move more shit here and below if found more special navigs that don't include BotZ handling
			NavArray[ LCenter+LExit+JSpot+TStart+ TEnd++] = N;
		}
		else if ( N.class == class'Botpack.TranslocStart' ) //Doesn't use SpecialCost
		{
			NavArray[ LCenter+LExit+JSpot+TStart+TEnd ] = NavArray[ LCenter+LExit+JSpot+TStart ];
			NavArray[ LCenter+LExit+JSpot+ TStart++] = N;
		}
		else if ( classIsChildOf( N.class, class'Botpack.JumpSpot') )
		{
			NavArray[ LCenter+LExit+JSpot+TStart+TEnd ] = NavArray[ LCenter+LExit+JSpot+TStart ];
			NavArray[ LCenter+LExit+JSpot+TStart ] = NavArray[ LCenter+LExit+JSpot ];
			NavArray[ LCenter+LExit+ JSpot++] = N;
		}
		else if ( N.class == class'Engine.LiftExit' )
		{
			NavArray[ LCenter+LExit+JSpot+TStart+TEnd ] = NavArray[ LCenter+LExit+JSpot+TStart ];
			NavArray[ LCenter+LExit+JSpot+TStart ] = NavArray[ LCenter+LExit+JSpot ];
			NavArray[ LCenter+LExit+JSpot ] = NavArray[ LCenter+LExit ];
			NavArray[ LCenter+ LExit++] = N;
		}
		else if ( N.class == class'Engine.LiftCenter' )
		{
			NavArray[ LCenter+LExit+JSpot+TStart+TEnd ] = NavArray[ LCenter+LExit+JSpot+TStart ];
			NavArray[ LCenter+LExit+JSpot+TStart ] = NavArray[ LCenter+LExit+JSpot ];
			NavArray[ LCenter+LExit+JSpot ] = NavArray[ LCenter+LExit ];
			NavArray[ LCenter+LExit ] = NavArray[ LCenter ];
			NavArray[ LCenter++] = N;
		}
	}

}

//*******************************************
//Called for each navig type to block/unblock

//Base LiftExit and LiftCenters
function CostBase( bool bCost)
{
	local int i, j;

	if ( bCost )
	{
		For ( i=LCenter+LExit-1 ; i>=0 ; i-- )
		{
//			NavArray[i].bSpecialCost = true;
			NavArray[i].Enable('SpecialHandling');
		}
		if ( TStart > 0 )
		{
			j = LCenter+LExit+JSpot+TStart;
			For ( i=j-TStart ; i<j ; i++ )
				NavArray[i].Enable('SpecialHandling');
		}
		return;
	}
	For ( i=LCenter+LExit-1 ; i>=0 ; i-- )
	{
//		NavArray[i].bSpecialCost = false;
		NavArray[i].Disable('SpecialHandling');
	}
	if ( TStart > 0 )
	{
		j = LCenter+LExit+JSpot+TStart;
		For ( i=j-TStart ; i<j ; i++ )
			NavArray[i].Disable('SpecialHandling');
	}
}

//Jump spots
function CostJump( bool bCost )
{
	local int i, j;

	j = LCenter+LExit+JSpot;
	if ( bCost )
	{
		For ( i=LCenter+LExit ; i<j ; i++ )
		{
			NavArray[i].bSpecialCost = true;
			NavArray[i].Enable('SpecialHandling');
		}
		return;
	}
	For ( i=LCenter+LExit ; i<j ; i++ )
	{
		NavArray[i].bSpecialCost = false;
		NavArray[i].Disable('SpecialHandling');
	}
}

//Translocator dest only, use starts as hack
function CostTransloc( bool bCost )
{
	local int i, j;

	j = LCenter+LExit+JSpot+TStart+TEnd;
	if ( bCost )
	{
		For ( i=j-TEnd ; i<j ; i++ )
		{
			NavArray[i].bSpecialCost = true;
			NavArray[i].Enable('SpecialHandling');
		}
		return;
	}
	For ( i=j-TEnd ; i<j ; i++ )
	{
		NavArray[i].bSpecialCost = false;
		NavArray[i].Disable('SpecialHandling');
	}
}
//End of Navig block/unblock routines
//********************************************

function CalcInvScaler()
{
	local inventory inv;
	local vector Lest, Most;

	ForEach Allactors (Class'inventory', inv)
	{
		if ( inv.Location.Z < Lest.Z )
			Lest.Z = inv.location.Z;
		if ( inv.Location.Y < Lest.Y )
			Lest.Y = inv.location.Y;
		if ( inv.Location.X < Lest.X )
			Lest.X = inv.location.X;

		if ( inv.Location.Z > Most.Z )
			Most.Z = inv.location.Z;
		if ( inv.Location.Y > Most.Y )
			Most.Y = inv.location.Y;
		if ( inv.Location.X > Most.X )
			Most.X = inv.location.X;
	}

	DistInvScaler = VSize( Most - Lest);

}

function NotifyMutator()
{
	local mutator M;
	local BaseLevelPoint BLP;
	local int i;

	For ( M=Level.Game.BaseMutator ; M!=none ; M=M.nextMutator )
		if ( M.IsA('BotzMutator') )
		{
			TheMutator = BotzMutator(M);
			break;
		}
	if ( TheMutator == none )	//ATENCIN: MUTADOR DE BOTZ SIEMPRE EXISTE!
	{
		TheMutator = Level.Game.BaseMutator.Spawn(class'BotzMutator');
		Level.Game.BaseMutator.AddMutator(TheMutator);
		TheMutator.MasterG = Self;
	}
	i = 0;
	ForEach AllActors (class'BaseLevelPoint', BLP)
	{
		TheMutator.SetBLP( BLP, i);
		i++;
	}
}

event Tick( float DeltaTime)
{
	local int i;
	local teleporter TheTelep;

	if ( FRand() < 0.5 )
		CheckBWP();

	if ( TickCount > 0 )
	{
		TickCount--;
		if ( TickCount == 0)
			NotifyMutator();
	}


//Localizar botz congelado luego de transloc
	if ( TTranker != none)
	{
		TTime -= DeltaTime;
		if ( TTime < 0 )
		{
			if ( VSize(TTranker.Location - TLocation) < 18 )
				TTranker.QueHacerAhora();
			TTranker = none;
		}
	}

	if ( (TTranker == none) && (FRand() < 0.15) )
		For ( i=0 ; i<24 ; i++ )
		{
			if ( (OldBotzList[i] != none) && (OldBotzList[i].Health > 0) && (OldBotzList[i].Physics == PHYS_Walking) && (OldBotzList[i].GetAnimGroup(OldBotzList[i].AnimSequence) == 'Ducking') )
			{
				TTranker = OldBotzList[i];
				TLocation = TTranker.Location;
				TTime = 1.5;
			}
		}

//Localizar botz trancado en un teletransportador
	if ( TeleTranker == none )
	{	TeleTranked = none;
		TeleTrankTime = 0;
		TeleSteps = 0;
	}
	if ( (TeleTranker == none) && (FRand() < 0.25) )	//Reducir uso de CPU
		For ( i=0 ; i<OldBotzCount ; i++ )
		{	TheTelep = GetNearestTelep( OldBotzList[i] );
			if ( TheTelep == none )
				break;
			if ( (OldBotzList[i] != none) && (OldBotzList[i].VectorInCylinder(TheTelep.Location, OldBotzList[i].Location, 50, 70 ) ) )
			{	TeleTranker = OldBotzList[i];
				TeleTranked = TheTelep;
				break;
			}
		}

	if ( TeleTranker != none )
	{
		TeleTrankTime += DeltaTime;
		if ( (TeleTrankTime > 0.25) && (TeleSteps == 0) )	//Intentar moverlo primero
		{
			TeleTranker.GotoState('Wander','Begin');	//Al fin le encuentro un gran uso al Wander
			TeleSteps = 1;
		}
		if ( (TeleTrankTime > 0.4) && (TeleSteps == 1) )	//No pudo moverse: esta trancado en el aire!!!
		{
			TeleTranker.SetLocation( Teletranker.Location - vect(0,0,5) );
			if ( TeleTranker.Region.Zone.bWaterZone )
				TeleTranker.SetPhysics( PHYS_Swimming );
			else
			{
				TeleTranker.bTickedJump = True;
				TeleTranker.SetPhysics( PHYS_Falling );
			}
			TeleSteps = 2;
		}
		if ( (TeleTrankTime > 2.5) && (TeleSteps == 2) )
		{
			TeleTranked.Touch(TeleTranker);
			TeleSteps = 3;
		}
		if ( (TeleTrankTime > 3.5) && (TeleSteps == 3) )	//Nada funciona, reaparecer bot
		{
			Tranker = TeleTranker;
			TrankTime = 11;
			TeleTranker = none;
		}
		if ( (TeleTranker != none) && ((!TeleTranker.VectorInCylinder(TeleTranked.Location, TeleTranker.Location, 50, 70) ) || (Teletranker.Health <= 0) || (TeleTranker.Acceleration != vect(0,0,0) )) )
			TeleTranker = none;
	}
//Localizar botz muerto que no reaparezca
	if ( Tranker == none )
		For ( i=0 ; i<OldBotzCount ; i++ )
			if ( (OldBotzList[i] != none) && (OldBotzList[i].Health <= 0) )
			{	Tranker = OldBotzList[i];
				break;
			}
	if ( Tranker != none )
	{
		TrankTime += DeltaTime;
		if ( TrankTime > 10 )
		{
//			Class'BotzFunctionManager'.static.SetVisibleAndValid( Tranker);
//			Tranker.Health = 100;
//			Level.Game.AddDefaultInventory( Tranker);
			Level.Game.RestartPlayer( Tranker);
		}
	}
	if ( (Tranker != none) && (Tranker.Health > 0) )
	{
		Tranker = none;
		TrankTime = 0;
	}
}

function CheckBWP()
{
	if ( (BwpCreator != none) && BwpCreator.bFinalPathsReady && BwpCreator.bSetFinalPaths )
		BwpCreator.EnforceWp();
}

function Teleporter GetNearestTelep( actor Other, optional float MaxDist)
{
	local navigationpoint n;
	local float BestDist, CurrentDist;
	local teleporter Best;

	if ( Other == none )
		return none;

	if ( MaxDist < 1.0 )
		BestDist = 99999.9;
	else
		BestDist = MaxDist;

	For ( n=Level.NavigationPointList ; n!=none ; n=n.nextNavigationPoint )
		if ( n.IsA('Teleporter') )
		{
			CurrentDist = VSize( Other.Location - n.Location);
			if ( CurrentDist < BestDist )
			{
				BestDist = CurrentDist;
				Best = Teleporter(n);
			}
		}
	return Best;
}

function String GetLevelName( string FullName ) //Eliminar estos caracteres: -,
{
	local int pos;
	local string StrStart;
	local string StrEnd;

	pos = InStr(FullName, ".");

	if (pos != -1)
		FullName = Left(FullName, Pos);

	pos = InStr(FullName, "-");
	while (pos != -1)
	{
		StrStart = Left(FullName, Pos);
		StrEnd = Right(FullName, Len(FullName) - Pos - 1);
		FullName = StrStart$StrEnd;
		pos = InStr(FullName, "-");
	}

	return FullName;
}

event Timer()
{
	local Botz OldBotz;
	local int i;

	ForEach AllActors (class'Botz', OldBotz)
	{
		OldBotzlist[i] = oldBotz;
		i++;
	}
	OldBotzCount = i;
}

function StartSpecialWP()
{
/*	local BaseBotzWp BBWP;
	local BotzWp BWP;
//	CreateFromText();

	ForEach AllActors (class'BaseBotzWP', BBWP)
		BBWP.InitializeWp();

	ForEach AllActors (class'BotzWp', BWP)
		if ( BWP.PathInfo == none )
			BWP.StartPathInfo();*/

}

final function FindCreator()
{
	ForEach AllActors (class'WpLoaderbase', BwpCreator)
		break;

	if ( BwpCreator != none )
	{
		BwpCreator.Master = self;
		BwpCreator.BeginTheWpProcess();
	}
}


static final function ReplaceText(out string Text, string Replace, string With)
{
	local int i;
	local string Input;
		
	Input = Text;
	Text = "";
	i = InStr(Input, Replace);
	while(i != -1)
	{	
		Text = Text $ Left(Input, i) $ With;
		Input = Mid(Input, i + Len(Replace));	
		i = InStr(Input, Replace);
	}
	Text = Text $ Input;
}

defaultproperties
{
}
